#!/usr/bin/env node
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const yargs_1 = __importDefault(require("yargs"));
const apis_1 = require("./apis");
(() => __awaiter(void 0, void 0, void 0, function* () {
    const res = yargs_1.default
        .scriptName('git-parser')
        .usage('$0 [args]')
        .option('path', {
        alias: 'p',
        demandOption: true,
        describe: 'lcov.info path',
        type: 'string',
    })
        .option('time', {
        alias: 't',
        describe: 'git diff start time',
        type: 'string',
    })
        .option('output', {
        alias: 'o',
        describe: 'switch stream',
        default: 'file',
        choices: ['file', 'stdio'],
    })
        .help().argv;
    yield apis_1.getIncrease(res.path, {
        since: res.time,
        stream: {
            name: res.output,
        },
    });
}))();
