"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LogParser = void 0;
const fs_extra_1 = __importDefault(require("fs-extra"));
const path_1 = __importDefault(require("path"));
const gitlog_1 = require("gitlog");
class LogParser {
    constructor(opt = {
        repo: process.cwd(),
    }) {
        this.opt = opt;
    }
    run() {
        return __awaiter(this, void 0, void 0, function* () {
            const res = yield this.exec();
            return res;
        });
    }
    exec() {
        return __awaiter(this, void 0, void 0, function* () {
            const rootPath = path_1.default.resolve(this.opt.repo || process.cwd(), '.git');
            if (!fs_extra_1.default.existsSync(rootPath)) {
                throw new Error('请选择 git 仓库运行');
            }
            const log = yield gitlog_1.gitlogPromise(Object.assign(Object.assign({}, this.opt), { number: 10000 }));
            return log;
        });
    }
}
exports.LogParser = LogParser;
