"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.StdoutStream = void 0;
const console_1 = require("console");
const index_1 = require("./index");
class StdoutStream extends index_1.Stream {
    constructor(content, ioType, opts) {
        super(content);
        this.opts = {};
        if (typeof ioType === 'string') {
            this.opts.ioType = ioType;
            this.opts.type = (opts === null || opts === void 0 ? void 0 : opts.type) || 'json';
            return;
        }
        if (ioType instanceof Object) {
            this.opts.ioType = ioType.ioType || 'stdout';
            this.opts.type = ioType.type || 'json';
            return;
        }
        this.opts.ioType = 'stdout';
        this.opts.type = 'json';
    }
    outToStream() {
        let res = '';
        if (this.opts.type === 'yaml') {
            res = super.dumpYaml();
        }
        else {
            res = this.dumpJSON(2);
        }
        const selfConsole = new console_1.Console(process.stdout, process.stderr);
        if (this.opts.ioType === 'stderr') {
            selfConsole.error(res);
        }
        else {
            selfConsole.log(res);
        }
    }
}
exports.StdoutStream = StdoutStream;
